function  fc_demo_call_back(s)
//-----------------------------------------------------------------------  
// function  fc_demo_call_back(s)
//
// The callback function used in Fc_demo()
//
// not to be used outside the function: Fc_demo()
//
//-----------------------------------------------------------------------  
//   $RCSfile: fc_demo_call_back.sci,v $
//  $Revision: 1.3 $
//      $Date: 2002/11/19 19:06:20 $
//  Copyright: IIF-LMB $Author: poluru $
//
//-----------------------------------------------------------------------
//  $Log: fc_demo_call_back.sci,v $
//  Revision 1.3  2002/11/19 19:06:20  poluru
//  errors check in Fc_demo
//
//  Revision 1.2  2002/11/10 22:15:44  poluru
//  errors check
//
//  Revision 1.1  2002/09/10 15:15:36  poluru
//  "macros" directory structure is created
//
//-----------------------------------------------------------------------

  
  f= findobj( 'tag','Fc_demo_f_fig');    
  h1= findobj( 'tag','Fc_demo_h1');
  h2= findobj( 'tag','Fc_demo_h2');
  ht22= findobj( 'tag','Fc_demo_ht22');
  h3= findobj( 'tag','Fc_demo_h3');
  e1= findobj( 'tag','Fc_demo_e1');
  e2= findobj( 'tag','Fc_demo_e2');
  e3= findobj( 'tag','Fc_demo_e3');
  pol= get(f,'userdata'); 
  z = (size(pol,2)+1)/2;
      
  lock1= evstr(get(f,'lock1'));
  lock2= evstr(get(f,'lock2'));
   
  // if the function is called by the slier: h1
  if s== 'h1_slider', 
    if lock1==0,
      set(f,'lock1',1);
      gh1=get(h1,'value'); 
      ep1=gh1 - z; 
      ep2 = sqrt(pol(1,gh1)^2+pol(2,gh1)^2); 
      ep2 =floor(ep2*1000);
      
      if pol(1,gh1)==0,
	if pol(2,gh1)>=0,
	  phi=%pi/2,
	else
	  phi=-%pi/2,
	end      
      else
	phi=atan(pol(2,gh1),pol(1,gh1));
      end
      ep3= floor(1000*pmodulo(phi,%pi*2));
      
      set(h2,'Max',ep2+10000);
      set(h2,'value',ep2);
      set(ht22,'String', string(10+ep2/1000));
      set(h3,'value',ep3);
      set(e1,'string',string(ep1));
      set(e2,'string',string(ep2/1000));
      set(e3,'string',string(ep3/1000));  
      set(f,'ep1_edit',ep1);
      set(f,'ep2_edit',ep2/1000);
      set(f,'ep3_edit',ep3/1000);
      
      clear ep1 ep2 ep3 gh1 phi pol
      
      set(f,'lock1',0);
    end;
    
  else
    // if the function is called by the push button: c_i
    if s== 'ep1_edit',
      
      [ep11,err]= evstr(get(e1,'string')); 
            
      if (err ~=0) | ep11 ==''| ep11 == [] | type(ep11)~=1,
	ep1 = string(evstr(get(f,'ep1_edit')));
	set(e1,'string',ep1);
	clear ep1 ep11 pol z
      
      else
	if (abs(floor(ep11(1)))>=z),
	  ep1 = string(evstr(get(f,'ep1_edit')));
	  set(e1,'string',ep1);
	  clear ep1 ep11 pol z
	  
	else
	  ep11 = ep11(1);
	  pol = get(f,'userdata'); 
	  ep1 = floor(ep11)+z;	
	  ep2 = sqrt(pol(1,ep1)^2 + pol(2,ep1)^2); 
	  ep2 =floor(ep2*1000);
	  
	  if pol(1,ep1)==0,
	    if pol(2,ep1)>=0,
	      phi=%pi/2,
	    else
	      phi=-%pi/2,
	    end;
	  else
	    phi = atan(pol(2,ep1),pol(1,ep1));
	  end;
	  
	  ep3 = floor(1000*pmodulo(phi,%pi*2));
	  
	  clear phi pol z
	  set(h1,'value',ep1);
	  set(h2,'Max',ep2+10000);
	  set(h2,'value',ep2);
	  set(ht22,'String', string(ep2+10));
	  set(h3,'value',ep3); 	  
	  set(e1,'string',string(floor(ep11)));
	  set(e2,'string',string(ep2/1000));
	  set(e3,'string',string(ep3/1000)); 
	  set(f,'ep1_edit',floor(ep11));
	  set(f,'ep2_edit',ep2/1000);
	  set(f,'ep3_edit',ep3/1000);
	
	  clear ep1 ep11 ep2 ep3
	end;
      end;
      
    else 
      // if the function is called by the sliders: h2 & h3	  
      if s== 'h23_slider' ,
	
	if lock1==0, 
	  set(f,'lock1',1);
	  gh1=get(h1,'value'); 
	  gh2=get(h2,'value');
	  gh3=get(h3,'value');
	  cp=cpolygon(pol); 
	  cp(gh1)= (gh2/1000)*exp(%i*gh3/1000);
	  
	  if lock2==0, 
	    set(f,'lock2',1)
	    
	    FC = polygon(Fsynthesis(cp));	    
	    xset('window',evstr(get(f,'window1')));
	    xbasc(); 
	    plotpol(FC);
	    
	    if get(f,'draw')=="yes",
	      xset('window',evstr(get(f,'window2'))); 
	      xbasc();
	      plotFs(cp);
	    end;  	    
	    
	    set(f,'lock2',0); 
	  end
	  
	  set(f,'userdata',polygon(cp));
	  set(e2,'string',string(gh2/1000));
	  set(e3,'string',string(gh3/1000));	
	  set(f,'ep2_edit',gh2/1000);
	  set(f,'ep3_edit',gh3/1000);  
	  
	  clear FC cp gh1 gh2 gh3
	  
	  set(f,'lock1',0);
	end;
      else
	// if the function is called by the push buttons: abs & arg
	if s=='ep23_edit'
	  
	  [ep2,err1]=evstr(get(e2,'string')); 
	  [ep3,err2]=evstr(get(e3,'string'));
	  
	  if err1 == 0 & ep2 ~= [] & type(ep2) == 1 & ep2 ~= '' & ...
		   err2 == 0 & ep3 ~= [] & ep3 ~= '' & type(ep3) == 1,
	    
	    if ep3(1) > 6.284,
	      ep3 = 6.284;
	      set(e3,'string',string(ep3));
	    end
	    
	    if ep3(1) < 0, 
	      ep3 = 0;
	      set(e3,'string',string(ep3));
	    end
	    
	    ep2 = ep2(1);
	    ep3 = ep3(1);
	    
	    gh1 = get(h1,'value'); 
	    cp = cpolygon(pol);  
	    cp(gh1) = ep2 * exp(%i * ep3);
	    xset('window',evstr(get(f,'window1')));
	    xbasc(); 
	    plotpol(polygon(Fsynthesis(cp)));
	    
	    if get(f,'draw')=="yes",
	      xset('window',evstr(get(f,'window2'))); 
	      xbasc();
	      plotFs(cp);
	    end;
	    
	    set(f,'userdata',polygon(cp));
	    set(h2,'Max',ep2*1000+10000);  
	    set(h2,'value',floor(ep2*1000));
	    set(ht22,'string', string(ep2+10));
	    set(h3,'value',floor(ep3*1000));
	    set(f,'ep2_edit',ep2);
	    set(f,'ep3_edit',ep3);  
	    clear cp ep2 ep3 err1 err2 gh1 pol
	  
	  else
	  
	    if err1 ~= 0 | ep2 == [] | ep2 == '' | type(ep2) ~= 1 ,
	      
	      ep2 = evstr(get(f,'ep2_edit'));
	      set(e2,'string',string(ep2));
	      clear ep2 err1
	    end;
	    
	    if err2 ~= 0 | ep3 == [] | ep3 == '' | type(ep3) ~= 1, 
	      
	      ep3 = evstr(get(f,'ep3_edit'));
	      set(e3,'string',string(ep3));
	      clear ep3 err2 		
	    end;
	  
	  end;
	
	else
	  //for displaying the help message (still be implemented)
	  if s=='help',
	    x_message(['This Demo allows interactive investigation of'; ...
		       'Fourier-coefficients (Fc) of complex contours.'; ...
		       ''; ...
		       'The Fourier coefficients c_i of a complex contour can be ' ; ...
		       'selected by choosing the index i with the upper slider, the' ; ...
		       'absolute value and the angle of the chosen c_i are then ' ; ...
		       'displayed and are editable by the lower two sliders. Beside' ; ...
		       'the sliders the values can be entered explicitly. After' ; ...
		       'pressing the ''set'' button, the value will be set.' ; ...
		       'When some some Fc is modified, a Fourier-Synthesis is ' ; ...
		       'calculated and and the resulting contour is displayed.'; ...
		       'If the demo is started with the ''showspectrum'' option,'; ...
		       'the power-spectrum of the current contour is plotted' ; ...
		       'additionally.' ],'OK');	
	  else 
	    //for exiting from the figure & graphical window
	    
	    if s=='exit',
	      
	      wi1=evstr(get(f,'window1'));
	      draw = get(f,'draw'); 
	      recall=get(f,'recall');
	      
	      if draw =="yes",
		wi2=evstr(get(f,'window2')); 
	      end;
	      
	      close(f);
	      
	      WI1 = winsid();
	      xpause(1000);
	      WI2 = winsid();
	      if length(WI2)>length(WI1),
		xdel(WI2(1));
	      end;
	      
	      wi=winsid();
	      if or(wi(1:$)==wi1),
		xdel(wi1);
	      end;
	      
	      if draw =="yes",
		if or(wi(1:$)==wi2)
		  xdel(wi2);		  
		end 
	      end
	      
	      if recall=='yes',
		global Fc_demos_lock;
		Fc_demos_lock = 0;
		resume(Fc_demos_lock);
	      end;	      
	    end;
	  end;
	end;
      end;
    end;  
  end;
  
endfunction











