.TH RT_DI  "July 2002" "Presto Group" "scilab function"
.so ../sci.an

.SH NAME
RT_DI - 2D-translation-invariant CT_DI-transformation of matrices with functions pairwise-addition and absolute-difference

.SH CALLING SEQUENCE
.nf
res = RT_DI(x )
.fi

.SH PARAMETERS
.TP 10
x    :
a matrix to be processed by the RT_DI.
.TP 10
res  :       
matrix of the result of the RT_DI transformation of x.

.SH DESCRIPTION
\fVRT_DI\fR (is a matrix transformation) performs CT_DI transformation using 
the commutative functions pairwise-addition and absolute-difference on the 
given matrix x (i.e. first w_DI transformation then ZS transformation).

.SH EXAMPLE 
.nf 
x = [1 2; 3 4];
res = RT_DI(x);  
.fi

.SH SEE ALSO
CT, CT_DI, CT_SZ, CT_ZS, MT, MT_DI, MT_SZ, MT_ZS, 
QT, QT_DI, QT_SZ, QT_ZS, RT, RT_SZ, RT_ZS

.SH AUTHOR
Bernard Haasdonk

