.TH pw_add  "July 2002" "Presto Group" "scilab function"
.so ../sci.an

.SH NAME 
pw_add - elementwise addition.
 
.SH CALLING SEQUENCE
.nf
res = pw_add(x, y)
.fi

.SH PARAMETERS
.TP 10
x     :      
first vector/matrix for computation
.TP 10
y     :      
second vector/matrix for computation, same size as x
.TP 10
res   :      
elementwise addition same size as x,y

.SH DESCRIPTION
\fVpw_add\fR dummy function needed for CT-transformation 
performing elementwise addition.

.SH EXAMPLE 
.nf 
x = [3:6; 5:8]; 
y = [1:4; 3:6];
res = pw_add(x, y);  
.fi

.SH SEE ALSO
pw_absdiff, pw_diffsquare, pw_max, pw_min

.SH AUTHOR
Bernard Haasdonk

