.TH visclass_2d  "July 2002" "Presto Group" "Scilab function"
.So ../Sci.An

.SH NAME 
visclass_2d - visualization of classification regions in 2 dimensions

.SH CALLING SEQUENCE
.Nf
visclass_2d(classifier,varargin)
.Fi

.SH PARAMETERS
.TP 16
classifier  : 
Name of the classifier like bayes_class, nneigh_class,
polynom_class etc. default value is:  dumb_class_2d

.TP 16
varargin    : 
Classification data of the classifier, for example p, m, k for
bayes_class, learn_data & labels for nneigh_class etc.

.SH DESCRIPTION
\fVvisclass_2d\fR visualizes the regions of classification of various
classifiers with 2-dimensional data.

.SH EXAMPLE 
.Nf 
visclass_2d();  
.Fi

.SH SEE ALSO
visclass, dumb_class_2d, bayes_class, bayes_class_2d, nneigh_class,
nneigh_class_2d, polynom_class

.SH AUTHOR
Bernard Haasdonk

